Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Control.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Control.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Control.java	(revision 4932)
@@ -0,0 +1,36 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+/**
+ * @author John Thompson, Greenstone Digital Library, University of Waikato
+ * @version 2.3d
+ */
+public interface Control {
+    public void destroy();
+    public void gainFocus();
+    public void loseFocus();
+}
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListEntry.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListEntry.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListEntry.java	(revision 4932)
@@ -0,0 +1,36 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+import org.w3c.dom.*;
+public interface DOMProxyListEntry 
+    extends Comparable {
+    public DOMProxyListEntry create(Element element);
+    public Element getElement();
+    public boolean isAssigned();
+    public void setAssigned(boolean assigned);
+    public void setElement(Element element);
+}
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListModel.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListModel.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/DOMProxyListModel.java	(revision 4932)
@@ -0,0 +1,237 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+
+import java.util.*;
+import javax.swing.*;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.w3c.dom.*;
+
+/** This class provides ListModel like access to a list of nodes within a DOM model.
+ * @author John Thompson, Greenstone Digital Library, University of Waikato
+ * @version 2.3d
+ */
+public class DOMProxyListModel
+    extends AbstractListModel {
+    protected Element root;
+    private DOMProxyListEntry class_type;
+    private HashMap cache = new HashMap();
+    private NodeList children = null;
+    private String tag_name;
+
+    /** Constructor.
+     * @param root the Element at the root of the subtree to be searched for appropriate child elements
+     * @param tag_name the name of appropriate elements as a String
+     * @param class_type the type of object to wrap the elements returned in, as a DOMProxyListEntry
+     */
+    public DOMProxyListModel(Element root, String tag_name, DOMProxyListEntry class_type) {
+	this.class_type = class_type;
+	this.root = root;
+	this.tag_name = tag_name;
+    }
+
+    /** Used to add an element into the underlying dom, and fire the appropriate repaint events. This version always adds the new element at the very head of the DOM. */
+    public synchronized void add(DOMProxyListEntry entry) {
+	Element element = entry.getElement();
+	if(root.hasChildNodes()) {
+	    Node sibling = root.getFirstChild();
+	    root.insertBefore(element, sibling);
+	    sibling = null;
+	}
+	else {
+	    root.appendChild(element);
+	}
+	element = null;
+	// Regardless fire update event
+	cache.clear();
+	fireIntervalAdded(this, 0, 0);
+    }
+
+    /** Used to add an element into the underlying dom, and fire the appropriate repaint events.
+     * @param index the index where the element should be inserted (relative of the other elements in this proxy list)
+     * @param element the Element to be inserted
+     */
+    public synchronized void add(int index, DOMProxyListEntry entry) {
+	///atherer.println("Add entry at " + index + " where size = " + getSize());
+	Element element = entry.getElement();
+	// retrieve the node where we want to insert
+	if(index < children.getLength()) {
+	    Node sibling = children.item(index);
+	    // Find the parent node
+	    Node parent_node = sibling.getParentNode();
+	    parent_node.insertBefore(element, sibling);
+	    sibling = null;
+	}
+	// If the index is too large, we are adding to the end of our list of entries. However you have to remember that this list is only a viewport on the entire DOM so there might be entries following this group that we actually want to insert before (not append at the very end!)
+	else {
+	    // Retrieve the currently last entry
+	    Node sibling = children.item(children.getLength() - 1);
+	    Node parent_node = sibling.getParentNode();
+	    sibling = sibling.getNextSibling();
+	    if(sibling != null) {
+		parent_node.insertBefore(element, sibling);
+	    }
+	    // Add to the root node
+	    else {
+		root.appendChild(element);
+	    }
+	}
+	// Regardless fire update event
+	cache.clear();
+	fireIntervalAdded(this, index, index);
+    }
+
+    /** Used to add an element into the underlying dom, and fire the appropriate repaint events. This version inserts the new entry immediately -after- the given entry in the DOM.
+     * @param entry the DOMProxyListEntry to be inserted
+     * @param proceeding_entry the DOMProxyListEntry immediately before where we want the new entry
+     */
+    public synchronized void addAfter(DOMProxyListEntry entry, DOMProxyListEntry proceeding_entry) {
+	Element element = entry.getElement();
+	Element proceeding_sibling = proceeding_entry.getElement();
+	Node parent_node = proceeding_sibling.getParentNode();
+	Node following_sibling = proceeding_sibling.getNextSibling();
+	if(following_sibling != null) {
+	    parent_node.insertBefore(element, following_sibling);
+	}
+	else {
+	    parent_node.appendChild(element);
+	}
+	// Regardless fire update event
+	cache.clear();
+	int index = indexOf(proceeding_entry) + 1;
+	fireIntervalAdded(this, index, index);
+    }
+
+    /** Used to add an element into the underlying dom, and fire the appropriate repaint events. This version inserts the new entry immediately -before- the given entry in the DOM.
+     * @param entry the DOMProxyListEntry to be inserted
+     * @param following_entry the DOMProxyListEntry immediately after where we want the new entry
+     */
+    public synchronized void addBefore(DOMProxyListEntry entry, DOMProxyListEntry following_entry) {
+	Element element = entry.getElement();
+	Element following_sibling = following_entry.getElement();
+	Node parent_node = following_sibling.getParentNode();
+	parent_node.insertBefore(element, following_sibling);
+	// Regardless fire update event
+	cache.clear();
+	int index = indexOf(entry);
+	fireIntervalAdded(this, index, index);
+    }
+
+    public synchronized void add(Node parent, DOMProxyListEntry entry, Node sibling) {
+	Element child = entry.getElement();
+	if(sibling != null) {
+	    parent.insertBefore(child, sibling);
+	}
+	else {
+	    parent.appendChild(child);
+	}
+	cache.clear();
+	int index = indexOf(entry);
+	fireIntervalAdded(this, index, index);
+    }
+
+    public synchronized ArrayList children() {
+	ArrayList child_list = new ArrayList();
+	int child_count = children.getLength();
+	for(int i = 0; i < child_count; i++) {
+	    child_list.add(class_type.create((Element)children.item(i)));
+	}
+	return child_list;
+    }
+
+    public synchronized boolean contains(DOMProxyListEntry entry) {
+	boolean found = false;
+	int size = getSize();
+	for(int i = 0; !found && i < size; i++) {
+	    DOMProxyListEntry sibling = (DOMProxyListEntry) getElementAt(i);
+	    if(sibling.equals(entry)) {
+		found = true;
+	    }
+	}
+	return found;
+    }
+
+    public synchronized Object getElementAt(int index) {
+	Object object = cache.get(new Integer(index));
+	if(object == null) {
+	    // Retrieve the required element
+	    Element element = (Element) children.item(index);
+	    // Now wrap it in the object of the users choice
+	    object = class_type.create(element);
+	    cache.put(new Integer(index), object);
+	}
+	return object;
+    }
+
+    public synchronized int indexOf(DOMProxyListEntry entry) {
+	Element element = entry.getElement();
+	int children_length = children.getLength();
+	for(int i = 0; i < children_length; i++) {
+	    Node node = children.item(i);
+	    if(element == node) {
+		return i;
+	    }
+	}
+	return -1;
+    }
+
+    public synchronized int getSize() {
+	if(children == null) {
+	    children = root.getElementsByTagName(tag_name);
+	}
+	return children.getLength();
+    }
+
+    public synchronized void refresh() {
+	fireContentsChanged(this, 0, getSize());
+    }
+
+    public synchronized void refresh(DOMProxyListEntry entry) {
+	int index = indexOf(entry);
+	fireContentsChanged(this, index, index);
+    }
+
+    public synchronized void remove(DOMProxyListEntry entry) {
+	remove(indexOf(entry));
+    } 
+
+    public synchronized void remove(int index) {
+	// Retrieve the required element
+	Node node = children.item(index);
+	// Find its parent
+	Node parent_node = node.getParentNode();
+	// Now remove it
+	parent_node.removeChild(node);
+	// Refresh model
+	cache.clear();
+	fireIntervalRemoved(this, index, index);
+    }
+}
+
+
+
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Format.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Format.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Format.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,43 +25,70 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Company:      The University of Waikato
  * Written:      06/05/02
  * Revised:      04/10/02 - Commented
+ *               14/07/03 - DOM Support
  **************************************************************************************/
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.cdm.Classifier;
-/** This class encapsulates all the information about a format command from the collection configuration. This includes both the 'general' formatting commands, and the commands targetted at specific classifiers or classification component types.
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.greenstone.gatherer.msm.MSMUtils;
+import org.w3c.dom.*;
+/** This class encapsulates all the information about a format command from the collection configuration. This includes both the 'general' formatting commands, and the commands targetted at specific classifiers or classification component types. This class is, unfortunately, the most complex in terms of DOM model support, since we have to maintain a live reference to any classifier this format applies to. We temporarily use the feature name as the format name attribute but since the order of classifiers can change, this of course gets horribly out of date. Before the CollectionDesignManager saves the CollectionConfiguration it calls a method in the FormatManager to force all of the Formats to update their name attributes.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
  * @version 2.3
  */
-public class Format {
-    /** If this format is of a true/false type, the current state. */
-    private boolean state = false;
-    /** The type of this format command, either FLAG, FORMAT or PARAM. */
-    private int type = -1;
-    /** The feature this format command affects. */
-    private Object feature = null;
-    /** If this format refers to a specific part of a feature, this indicates the part. */
-    private String part = null;
-    /** A command string, which may include a specific HTML chunk used to format a control. */
-    private String value = null;
-    /** An element of the format type enumeration. A true/false option. */
-    static final public int FLAG = 0;
-    /** An element of the format type enumeration. A string parameter. */
-    static final public int VALUE = 1;
+public class Format 
+    implements DOMProxyListEntry {
+
     /** The default features as specified by the Greenstone Developers manual. */
     static final public String DEFAULT_FEATURES[] = {"", "DocumentArrowsBottom","DocumentButtons","DocumentContents","DocumentHeading","DocumentImages","DocumentText","DocumentUseHTML","Search"};
     /** The list of known feature parts. */
     static final public String DEFAULT_PARTS[] = {"","DateList","HList","Invisible","VList"};
+
+    /** Not all features have an associated part, such as those in the default features list (apart from Search which does have parts!) */
+    static public boolean canHavePart(String name) {
+	return !(name.equalsIgnoreCase(DEFAULT_FEATURES[1]) || name.equalsIgnoreCase(DEFAULT_FEATURES[2]) || name.equalsIgnoreCase(DEFAULT_FEATURES[3]) || name.equalsIgnoreCase(DEFAULT_FEATURES[4]) || name.equalsIgnoreCase(DEFAULT_FEATURES[5]) || name.equalsIgnoreCase(DEFAULT_FEATURES[6]) || name.equalsIgnoreCase(DEFAULT_FEATURES[7]));
+    }
+
+    static public boolean isParamType(String name) {
+	return (name.equalsIgnoreCase(DEFAULT_FEATURES[1]) || name.equalsIgnoreCase(DEFAULT_FEATURES[3]) || name.equalsIgnoreCase(DEFAULT_FEATURES[5]) || name.equalsIgnoreCase(DEFAULT_FEATURES[7]));
+    }
+
+    /** If this format is altering a Classifier then this is the classifier in question. */
+    private Classifier classifier = null;
+    /** The element this format is based on. */
+    private Element element = null;
+    /** We keep a copy of the part because its slightly more computationally tricky to calculate. */
+    private String part = null;
+    /** Cached result of toString. */
+    private String text = null;
+
+    /** Constructor only to be used during DOMProxyListModel initialization. */
+    public Format() {
+    }
+
+    public Format(Element element) {
+	this.element = element;
+	// Immediately check if we are dealing with a classifier, by retrieving the feature name. If it is a classifier, then restore the live reference immediately before anything changes it.
+	Object object = getFeature();
+	if(object instanceof Classifier) {
+	    classifier = (Classifier) object;
+	}
+	else {
+	    String feature = (String) object;
+	    if(feature.toUpperCase().startsWith(Classifier.CLASSIFIER_PREFIX)) {
+		// Extract the integer index
+		int index = Integer.parseInt(feature.substring(Classifier.CLASSIFIER_PREFIX.length()));
+		// Subtract one (as java is 0-2 where G2 is 1-3)
+		index = index - 1;
+		// Retrieve the appropriate classifier
+		classifier = CollectionDesignManager.classifier_manager.getClassifier(index);
+	    }
+	}
+    }
+
     /** Constructor for a flag format command.
      * @param feature The <Strong>Object</strong> this format affects.
@@ -80,9 +97,9 @@
      */
     public Format(Object feature, String part, boolean state) {
-	this.feature = feature;
-	this.part = part;
-	this.state = state;
-	this.type = FLAG;
-    }
+	element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.FORMAT_ELEMENT);
+	setName(feature, part);
+	setState(state);
+    }
+
     /** Constructor for a format-string format command.
      * @param feature The <Strong>Object</strong> this format affects.
@@ -91,108 +108,206 @@
      */
     public Format(Object feature, String part, String value) {
-	this.feature = feature;
-	this.part = part;
-	this.type = VALUE;
-	this.value = value;
-    }
+	element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.FORMAT_ELEMENT);
+	setName(feature, part);
+	setValue(value);
+    }
+
+    public boolean canHavePart() {
+	return canHavePart(getName());
+    }
+
+    public int compareTo(Object object) {
+	if(object == null) { // It seems that occasionally compareTo is called and somehow null ends up in comparison.
+	    return -1;
+	}
+	if(object instanceof Format && element != null) {
+	    return element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE).compareTo(((Format)object).getName());
+	}
+	return toString().compareTo(object.toString());
+    }
+
+    public DOMProxyListEntry create(Element element) {
+	return new Format(element);
+    }
+
+    public boolean equals(Object object) {
+	return (compareTo(object) == 0);
+    }
+
+    public Element getElement() {
+	return element;
+    }
+
     /** Method to retrieve the value of feature, which may either be a String or a Classifier.
      * @return The value of feature as an <strong>Object</strong>.
      */
     public Object getFeature() {
-	return feature;
-    }
-    /** Method to retrieve the value of part.
+	if(classifier != null) {
+	    return classifier;
+	}
+	else if(element != null) {
+	    String name = element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
+	    // Remove part
+	    String part = getPart();
+	    String feature;
+	    if(part != null) {
+		feature = name.substring(0, name.length() - part.length());
+	    }
+	    else {
+		feature = name;
+	    }
+	    part = null;
+	    name = null;
+	    // If the feature now refers to a classifier, retrieve it.
+	    if(feature.toUpperCase().startsWith(Classifier.CLASSIFIER_PREFIX)) {
+		// Extract the integer index
+		int index = Integer.parseInt(feature.substring(Classifier.CLASSIFIER_PREFIX.length()));
+		// Subtract one (as java is 0-2 where G2 is 1-3)
+		index = index - 1;
+		// Retrieve the appropriate classifier
+		classifier = CollectionDesignManager.classifier_manager.getClassifier(index);
+		return classifier;
+	    }
+	    else {
+		return feature;
+	    }
+	}
+	else {
+	    return "Error";
+	}
+    }
+
+    public String getName() {
+	if(element != null) {
+	    return element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
+	}
+	return "Error";
+    }
+
+    /** Method to retrieve the value of part. Of course there may not be one, in which case return ""
      * @return The value of part as a <Strong>String</strong>.
      */
     public String getPart() {
+	if(part == null && element != null) {
+	    // To determine a part, we retrieve the Format name, then look for one of our recognized parts
+	    String name = element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
+	    // DEFAULT_PARTS[0] is an empty string to correctly enable comboboxes.
+	    name = name.toLowerCase();
+	    for(int i = 1; part == null && i < DEFAULT_PARTS.length; i++) {
+		if(name.endsWith(DEFAULT_PARTS[i].toLowerCase())) {
+		    part = DEFAULT_PARTS[i];
+		}
+	    }
+	    if(part == null) {
+		part = DEFAULT_PARTS[0];
+	    }
+	}
 	return part;
     }
-    /** Method to retrieve this formats special Greenstone position code.
-     * @return A <strong>String</strong> which distinctly indicates this classifiers position.
-     * @see org.greenstone.gatherer.cdm.Classifier
-     */
-    public String getPosition() {
-	///ystem.err.println("Retrieving the name of feature " + feature);
-	String position = null;
-	if(feature instanceof Classifier) {
-	    position = ((Classifier)feature).getPositionString();
-	}
-	else {
-	    position = feature.toString();
-	}
-	///ystem.err.println("Result: " + position + part);
-	return position + part;
-    }
+
     /** Method to retrieve the value of state.
-     * @param The value of state as a <i>boolean</i>.
+     * @return value of state as a <i>boolean</i>.
      */
     public boolean getState() {
-	return state;
-    }
-    /** Method to retrieve the value of type.
-     * @param The value of type as an <i>int</i>.
-     */
-    public int getType() {
-	return type;
-    }
+	return (element != null && element.getAttribute(CollectionConfiguration.VALUE_ATTRIBUTE).equals(CollectionConfiguration.TRUE_STR));
+    }
+
     /** Retrieve the value of value.
      * @return A <strong>String</strong> which is the value of value.
      */
     public String getValue() {
+	String value = "Error";
+	if(element != null) {
+	    value = MSMUtils.getValue(element);
+	}
 	return value;
     }
+
+    public boolean isAssigned() {
+	return (element != null && !element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.FALSE_STR));
+    }
+
+    public boolean isParamType() {
+	return (element != null && element.getAttribute(CollectionConfiguration.VALUE_ATTRIBUTE).length() > 0);
+    }
+
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (assigned ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	}
+    }
+
+    public void setElement(Element element) {
+	this.element = element;
+	part = null;
+	text = null;
+	// Establish the classifier reference, if necessary
+	getFeature();
+    }
+
+    public void setName(Object feature, String part) {
+	// Can't do anything unless an element exists.
+	if(element != null) {
+	    this.part = part; // Easier for later on.
+	    if(feature instanceof Classifier) {
+		classifier = (Classifier) feature;
+		element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, classifier.getPositionString() + part);
+	    }
+	    else {
+		element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, feature.toString() + part);
+	    }
+	    text = null;
+	}
+    }
+
     /** Set the value of state.
      * @param state The new value for state as a <i>boolean</i>.
      */
     public void setState(boolean state) {
-	this.state = state;
-    }
-    /** Set the value of type.
-     * @param type The new value for type as an <i>int</i>.
-     */
-    public void setType(int type) {
-	this.type = type;
-    }
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.VALUE_ATTRIBUTE, (state ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	    text = null;
+	}
+    }
+
     /** Set the value of value. Hmmm.
      * @param value The new value from value as a <strong>String</strong>.
      */
     public void setValue(String value) {
-	this.value = value;
-    }
+	if(element != null) {
+	    MSMUtils.setValue(element, value);
+	    text = null;
+	}
+    }
+
     /** Method to translate this classes information into a line of text as you would expect in the collection configuration file.
      * @return A <strong>String</strong> containing the format command.
      */
     public String toString() {
-	String text = "format ";
-	text = text + getPosition() + " ";
-	switch(type) {
-	case FLAG:
-	    if(state) {
-		text = text + "true";
+	if(text == null && element != null) {
+	    StringBuffer temp = new StringBuffer(CollectionConfiguration.FORMAT_STR);
+	    temp.append(" ");
+	    temp.append(element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE));
+	    temp.append(" ");
+	    String value = element.getAttribute(CollectionConfiguration.VALUE_ATTRIBUTE);
+	    if(value.length() > 0) {
+		temp.append(value);
 	    }
 	    else {
-		text = text + "false";
-	    }
-	    break;
-	default:
-	    text = text + "\"" + value + "\"";
+		temp.append("\"");
+		temp.append(MSMUtils.getValue(element));
+		temp.append("\"");
+	    }
+	    text = temp.toString();
+	    temp = null;
 	}
 	return text;
     }
-    /** Retrieve the type of a certain named feature.
-     * @param name The name of the feature as a <strong>String</strong>.
-     * @return An <i>int</i> indicating the type, and hence the controls needed to edit this type.
-     */
-    static public int getType(String name) {
-	int index = -1;
-	for(int i = 1; i < DEFAULT_FEATURES.length; i++) {
-	    if(name.equalsIgnoreCase(DEFAULT_FEATURES[i])) {
-		index = i;
-	    }
-	}
-	if(index == 1 || index == 3 || index == 5 || index == 7) {
-	    return FLAG;
-	}
-	return VALUE;
+
+    public void update() {
+	if(classifier != null) {
+	    element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, classifier.getPositionString() + getPart());
+	    text = null;
+	}
     }
 }
